<?php
 /**
  * CMDB Category view for global categories
  *
  * @package i-doit
  * @subpackage Contact
  * @author Andre Woesten <awoesten@i-doit.de>
  * @version Niclas Potthast <npotthast@i-doit.org> - 2006-10-10
  * @copyright synetics GmbH
  * @license http://dev.perl.org/perl6/rfc/346.html Artistic License 2.0
  */
 class isys_contact_view_detail_person extends isys_contact_view_detail {
 	/**
 	 * @return integer
 	 */
 	public function get_id() {
 		return C__CONTACT__VIEW__DETAIL_PERSON;
 	}

 	public function get_record_id_constant(){
 		return C__CONTACT_PERSON_ID;
 	}

 	public function get_menu_selection() {
 		return C__CONTACT_TREE__PERSON_MASTER_DATA;
 	}

 	public function get_view_constant()	{
 		return C__CONTACT__VIEW__DETAIL_PERSON;
 	}

 	public function get_name()	{
 		return "Person";
 	}

 	/**
 	* create a new record for a (birth-status)
 	* and return the id by reference
 	* @return bool
 	* @param &$p_int_record_id (id of new record - by reference)
 	* @param $p_int_fk, optional foreign key i.e. isys_organisation_intern_iop__id
 	*/
 	public function create_element(&$p_int_record_id, $p_int_fk){
		$p_new_id = -1; // no success
		$intRetCode = ISYS_TRUE;
		$l_dao_cmdb	= $this->get_dao_cmdb();

		$p_int_record_id = -1;
		
		return $intRetCode;
 	}

 	/**
 	* save a record
 	*
 	* @param integer $p_int_record_id - record id to save
 	* @return bool
 	*/
 	public function save_element(&$p_int_record_id, &$p_oldStatus) {
 		global $g_comp_template;
 		global $g_comp_database;
 		global $g_rs;
 		global $g_comp_session;
 		
 		$l_posts	= $this->get_module_request()->get_posts();
		$l_gets		= $this->get_module_request()->get_gets();
				
 		$l_dao_cmdb	= $this->get_dao_cmdb();
 		$intRetCode = ISYS_FALSE;
		$p_cat      = new isys_cmdb_dao_category_g_contact($g_comp_database);
 		
 		if ($p_int_record_id <= 0) {
 			$l_update = "INSERT INTO ";
 			$l_where = "";
 		} else {
 			$l_update = "UPDATE ";
 			$l_where =
				"WHERE ".
					"isys_person_intern__id = '".$p_int_record_id."' ";
 		}
 		
 		$l_strSql =
 			$l_update.
				"isys_person_intern ".
			"SET ".
				"isys_person_intern__isys_organisation_intern_iop__id	= ".$l_dao_cmdb->convert_sql_id($l_posts['C__CONTACT__PERSON_ASSIGNED_ORGANISATION']).", ".
				"isys_person_intern__last_name = ".$l_dao_cmdb->convert_sql_text($l_posts['C__CONTACT__PERSON_LAST_NAME'])." ,".
				"isys_person_intern__first_name = ".$l_dao_cmdb->convert_sql_text($l_posts['C__CONTACT__PERSON_FIRST_NAME'])." ,".
				"isys_person_intern__mail_address = ".$l_dao_cmdb->convert_sql_text($l_posts['C__CONTACT__PERSON_MAIL_ADDRESS'])." ,".
				"isys_person_intern__phone_company = ".$l_dao_cmdb->convert_sql_text($l_posts['C__CONTACT__PERSON_PHONE_COMPANY'])." ,".
				"isys_person_intern__phone_home = ".$l_dao_cmdb->convert_sql_text($l_posts['C__CONTACT__PERSON_PHONE_HOME'])." ,".
				"isys_person_intern__phone_mobile = ".$l_dao_cmdb->convert_sql_text($l_posts['C__CONTACT__PERSON_PHONE_MOBILE'])." ,".
				"isys_person_intern__fax = ".$l_dao_cmdb->convert_sql_text($l_posts['C__CONTACT__PERSON_FAX'])." ,".
				"isys_person_intern__department = ".$l_dao_cmdb->convert_sql_text($l_posts['C__CONTACT__PERSON_DEPARTMENT'])." ,".
				"isys_person_intern__status = '".C__RECORD_STATUS__NORMAL."', ";
			
			if($g_rs->check(isys_rs_system::path_maker(C__MODULE__CMDB), C__RS__RIGHT_SYSOP) || $g_comp_session->get_user_id() == $p_int_record_id) {
				//throw new isys_exception_rs("You do not have sufficient access rights for editing ". $l_posts['C__CONTACT__PERSON_USER_NAME']);
				
				$l_strSql .=
					"isys_person_intern__title = ".$l_dao_cmdb->convert_sql_text($l_posts['C__CONTACT__PERSON_USER_NAME'])." ,";
				
				// set password as md5, if password is set in textbox
				if(!empty($l_posts['C__CONTACT__PERSON_PASSWORD'])) {
					$l_strSql.= "isys_person_intern__user_pass = '".md5($l_posts['C__CONTACT__PERSON_PASSWORD'])."' ,";
				}
			}
			
			$l_strSql.=
				"isys_person_intern__description = ".
					$l_dao_cmdb->convert_sql_text($l_posts['C__CMDB__CAT__COMMENTARY'])." ".
					
				$l_where.";";
		
		if ($l_dao_cmdb->update($l_strSql)) {
			
			$this->m_logbook_query = $l_strSql;
			
			if (!empty($l_posts['C__CONTACT__PERSON_PASSWORD'])) {
				global $g_mail;
				
				if (!empty($g_mail["smtp-host"])) {
					$l_mailer = new isys_library_mail();
					
					if($l_mailer->check_address($l_posts['C__CONTACT__PERSON_MAIL_ADDRESS'])) {
						
						$l_mailer->IsSMTP();
						
						/* Configure mail */
	 					$l_mailer->AddAddress	($l_posts['C__CONTACT__PERSON_MAIL_ADDRESS']);
						$l_mailer->Subject = 	$g_mail["sub-prefix"] . "Password change";
						
						$l_message = str_replace(
												array
												(
													"%FIRSTNAME%",
													"%LASTNAME%",
													"%PASSWORD%",
													"%EMAIL%",
													"%COMMENT%",
													"%USERNAME%",
													"%USERID%"
												),
												array
												(
													$l_posts['C__CONTACT__PERSON_FIRST_NAME'],
													$l_posts['C__CONTACT__PERSON_LAST_NAME'],
													$l_posts['C__CONTACT__PERSON_PASSWORD'],
													$l_posts['C__CONTACT__PERSON_MAIL_ADDRESS'],
													$l_posts['C__CMDB__CAT__COMMENTARY'],
													$l_posts['C__CONTACT__PERSON_USER_NAME'],
													$p_int_record_id
													
												),
												sprintf(C__CONTACT_MSG__PASSWORD));
						
						if (strlen($l_message) > 2) {
			 				$l_mailer->Body = 		$l_message;
							
			 				if(!$l_mailer->Send()) {
			 					global $g_error;
			 					$g_error = "Mail notification to: ".
			 											$l_posts['C__CONTACT__PERSON_MAIL_ADDRESS']." failed.\n\n".
			 											"Error-Info: ". $l_mailer->ErrorInfo."\n\n".
			 								"If you want to disable mail notifications, remove smtp-host from ".
			 								"\$g_mail in src/config.inc.php.";
			 				}
						}
					}
				}
			}
			
			
			if ($p_int_record_id < 0) {
				$p_int_record_id = $l_dao_cmdb->get_database_component()->get_last_insert_id();
				
				// Nagios module installed?
				/*
				$l_modNagios = $this->get_module_request()->get_module_manager()->get_by_id(C__MODULE__NAGIOS);
				if ($l_modNagios) {
					$l_n = new isys_contact_view_detail_nagios_person($this->get_module_request());
					$l_n->save_element($p_int_record_id);
				}*/
				
				$l_gets = $this->m_modreq->get_gets();
				$l_gets[C__CONTACT_PERSON_ID] = $p_int_record_id;
				$_GET[C__CONTACT_PERSON_ID] = $p_int_record_id;
				
				$this->m_modreq->_internal_set_private("m_get", $l_gets);
				$this->trigger_module_reload();
				$this->readapt_form_action();
			}
			
			return true;
		}
		return false;
 	}
	
 	public function get_title_by_id($p_id) {
 		$l_data = array();
 		$this->get_data_by_id($p_id, $l_data);
 		return $l_data["isys_person_intern__title"];
 	}
 	
 	/**
 	 * daten f�r die aktuelle $p_id auslesen und
 	 * im array $p_arrData per referenz zur�ckgeben.
 	 *
 	 * @param integer $p_id
 	 * @param array $p_arrData
 	 * @return bool
 	 */
 	public function get_data_by_id($p_id, &$p_arrData){
 		$l_dao_cmdb	= $this->get_dao_cmdb();
 		$intRetCode = ISYS_FALSE;

 		$l_strSql 	=
			"SELECT * FROM  isys_person_intern ".
			"WHERE isys_person_intern__id = '".$p_id."';";

		$l_result = $l_dao_cmdb->retrieve($l_strSql);

		if ($l_result) {
			if($l_result->num_rows() > 0)	{
				$p_arrData 	= $l_result->get_row();
				$intRetCode = ISYS_TRUE;
			}
		}

 		return $intRetCode;
 	}

 	/**
 	 * Describes possible errors in the form
 	 *
 	 * @param isys_cmdb_dao_category $p_cat
 	 * @author Niclas Potthast <npotthast@i-doit.org> - 2006-10-06
 	 * @return bool
 	 */
	public function is_post_data_valid() {
		global $g_active_modreq;
		global $g_comp_template_language_manager;

		$l_retValid         = ISYS_TRUE;
		$l_arrTomAdditional = array();
		$l_posts            = $g_active_modreq->get_posts();
		$l_tpl              = $this->get_module_request()->get_template();
		
		//passwords not identical
 		if ($l_posts["C__CONTACT__PERSON_PASSWORD"] !=
 			$l_posts["C__CONTACT__PERSON_PASSWORD_SECOND"])
 		{
 			$l_arrTomAdditional["C__CONTACT__PERSON_PASSWORD_SECOND"]["p_strInfoIconError"] = 
 				$g_comp_template_language_manager->{"[Passwort nicht identisch!]"};
 		}
		
 		//fields must not be empty
 		if ($l_posts["C__CONTACT__PERSON_FIRST_NAME"]=="") {
 			$l_arrTomAdditional["C__CONTACT__PERSON_FIRST_NAME"]["p_strInfoIconError"] = 
 				$g_comp_template_language_manager->{"LC___UNIVERSAL__ERROR_INFO_ICON"};
 		}
 		if ($l_posts["C__CONTACT__PERSON_LAST_NAME"]=="") {
 			$l_arrTomAdditional["C__CONTACT__PERSON_LAST_NAME"]["p_strInfoIconError"] = 
 				$g_comp_template_language_manager->{"LC___UNIVERSAL__ERROR_INFO_ICON"};
 		}
 		if ($l_posts["C__CONTACT__PERSON_USER_NAME"]=="") {
 			$l_arrTomAdditional["C__CONTACT__PERSON_USER_NAME"]["p_strInfoIconError"] = 
 				$g_comp_template_language_manager->{"LC___UNIVERSAL__ERROR_INFO_ICON"};
 		}
 		if ($l_posts["C__CONTACT__PERSON_PASSWORD"]=="") {
 			$l_arrTomAdditional["C__CONTACT__PERSON_PASSWORD"]["p_strInfoIconError"] = 
 				$g_comp_template_language_manager->{"LC___UNIVERSAL__ERROR_INFO_ICON"};
 		}
 		if ($l_posts["C__CONTACT__PERSON_PASSWORD_SECOND"]=="") {
 			$l_arrTomAdditional["C__CONTACT__PERSON_PASSWORD_SECOND"]["p_strInfoIconError"] = 
 				$g_comp_template_language_manager->{"LC___UNIVERSAL__ERROR_INFO_ICON"};
 		}
		
 		//fields have wrong format
 		if ($l_posts["C__CONTACT__PERSON_MAIL_ADDRESS"]=="") {
 			$l_arrTomAdditional["C__CONTACT__PERSON_MAIL_ADDRESS"]["p_strInfoIconError"] = 
 				$g_comp_template_language_manager->{"[keine emailadresse!]"};
 		}
		
 		//save the array when post data is invalid
 		$this->m_cat->set_additional_rules(
 			$l_retValid == ISYS_FALSE ?
 			$l_arrTomAdditional :
 			ISYS_NULL);

 		return $l_retValid;
	}

	/**
	 * Loads isys_person_intern conform user information via ldap
	 *
	 * @param array &$p_data
	 * 
	 * @return bool
	 */
	public function load_by_ldap(&$p_data) {
		global $g_mod_ldap, $g_dbg;
		
		if (is_object($g_mod_ldap)) {
			$l_ldap = NULL;
			
			/**
			 * @var isys_library_ldap
			 */
			try {
				
				$l_ldap = $g_mod_ldap->get_library_by_id($p_data["isys_person_intern__isys_ldap__id"], $p_connection_array);
				
				$p_data["ldap_server"] = $p_connection_array["isys_ldap__hostname"];
				
			} catch (Exception $e) {
				if (is_object($g_dbg)) {
					$g_dbg->handle(	isys_debugger::c_err_warning,
									$e->getMessage());
				}
				
				isys_glob_display_error($e->getMessage());
				
				return false;
			}
			
			$l_timelimit = (!empty($p_connection_array["isys_ldap__timelimit"])?
								intval($p_connection_array["isys_ldap__timelimit"]):
								C__DEFAULT__TIMELIMIT);
			
			$l_user = $l_ldap->read(	$p_data["isys_person_intern__ldap_dn"],
										"(objectclass=*)",
										array(
											"cn", "sn", "displayname", "company", "department", "mobile",
											"givenname", "mail", "l", "description", "telephonenumber",
											"homephone", "facsimiletelephonenumber"),
										0,
										1,
										$l_timelimit);
			
			if (($l_count = $l_ldap->count($l_user))) {
				
				$l_entries = $l_ldap->get_entries($l_user);
				$l_ar = $l_ldap->format_entry($l_entries[0]);
				
				$p_data["ldap_cn"] = $l_ar["cn"][0];
				
				$p_data["isys_person_intern__mail_address"] = $l_ar["mail"][0];
				
				$p_data["isys_person_intern__fist_name"] = $l_ar["givenname"][0];
				$p_data["isys_person_intern__last_name"] = $l_ar["sn"][0];
				
				$p_data["isys_person_intern__phone_company"] = $l_ar["telephonenumber"][0];
				$p_data["isys_person_intern__phone_mobile"] = $l_ar["mobile"][0];
				$p_data["isys_person_intern__phone_home"] = $l_ar["homephone"][0];
				$p_data["isys_person_intern__fax"] = $l_ar["facsimiletelephonenumber"][0];
				
				$p_data["isys_person_intern__department"] = $l_ar["department"][0];
				
				$p_data["ldap_company"] = $l_ar["company"][0];
				$p_data["ldap_description"] = $l_ar["description"][0];
				
			}
										
		} else {
			return false;	
		}
	}
	
	
 	/**
 	 * @version Niclas Potthast <npotthast@i-doit.org> - 2��6-10-06
 	 * @return string "Detail Person" - ?
 	 */
 	public function process() {
 		global $g_rs, $g_comp_session;
 		
 		parent::process();
 		
 		$l_posts   = $this->get_module_request()->get_posts();
 		$l_gets    = $this->get_module_request()->get_posts();
 		$l_tpl     = $this->get_module_request()->get_template();
 		$l_navbar  = $this->get_module_request()->get_navbar();
		
 		if ($l_gets[C__CONTACT__GET__MENU_SELECTION] == C__CONTACT_TREE__GROUP_MAIN) {
	 		$l_navbar->set_active(ISYS_TRUE, C__NAVBAR_BUTTON__DELETE);
	 		$l_navbar->set_active(ISYS_FALSE, C__NAVBAR_BUTTON__ARCHIVE);
	 		die();
 		}
		
 		$l_tpl->assign("username_edit", true);
 		
 		$l_arrData = array();
 		
 		if($this->get_data_by_id(
 			$_GET[C__CONTACT_PERSON_ID],
 			$l_arrData))
 		{
 			if (!empty($l_arrData["isys_person_intern__ldap_dn"])) {
 				/* LDAP specific processing */
 				$this->load_by_ldap($l_arrData);
 				
 				$l_tpl->assign("ldap_server", $l_arrData["ldap_server"]);
 				
 				$l_tpl->assign("ldap_dn", $l_arrData["isys_person_intern__ldap_dn"]);
 				$l_tpl->assign("ldap_cn", $l_arrData["ldap_cn"]);
 				$l_tpl->assign("ldap_company", $l_arrData["ldap_company"]);
 				$l_tpl->assign("ldap_description", $l_arrData["ldap_description"]);
 			}
 			
 			if($g_rs->check(isys_rs_system::path_maker(C__MODULE__CMDB), C__RS__RIGHT_SYSOP) || 
 				$g_comp_session->get_user_id() == $l_arrData["isys_person_intern__id"])
 					$l_tpl->assign("username_edit", true);
 			else {
 				$l_navbar->set_active(ISYS_FALSE, C__NAVBAR_BUTTON__EDIT);
 				$l_tpl->assign("username_edit", false);
 			}
 			
	 		$l_rules["C__CONTACT__PERSON_FIRST_NAME"]["p_strValue"] =
				$l_arrData["isys_person_intern__first_name"];
			$l_rules["C__CONTACT__PERSON_LAST_NAME"]["p_strValue"] =
				$l_arrData["isys_person_intern__last_name"];
			$l_rules["C__CONTACT__PERSON_MAIL_ADDRESS"]["p_strValue"] =
				$l_arrData["isys_person_intern__mail_address"];
			$l_rules["C__CONTACT__PERSON_PHONE_COMPANY"]["p_strValue"] =
				$l_arrData["isys_person_intern__phone_company"];
			$l_rules["C__CONTACT__PERSON_PHONE_HOME"]["p_strValue"] =
				$l_arrData["isys_person_intern__phone_home"];
			$l_rules["C__CONTACT__PERSON_PHONE_MOBILE"]["p_strValue"] =
				$l_arrData["isys_person_intern__phone_mobile"];
			$l_rules["C__CONTACT__PERSON_FAX"]["p_strValue"] =
				$l_arrData["isys_person_intern__fax"];
			$l_rules["C__CONTACT__PERSON_DEPARTMENT"]["p_strValue"] =
				$l_arrData["isys_person_intern__department"];
			$l_rules["C__CONTACT__PERSON_ASSIGNED_ORGANISATION"]
				["p_strSelectedID"] =
				$l_arrData["isys_person_intern__isys_organisation_intern_iop__id"];
			
			$l_rules["C__CONTACT__PERSON_USER_NAME"]["p_strValue"] =
				$l_arrData["isys_person_intern__title"];
			
			$l_rules["C__CMDB__CAT__COMMENTARY"]["p_strValue"]	=
				$l_arrData["isys_person_intern__description"];
				
			$l_rules["C__CATG__MAINTENANCE_OBJ_MAINTENANCE"]["p_arData"] =
				$l_arrObjTypeMaintenance;
			$l_rules["C__CATG__MAINTENANCE_OBJ_MAINTENANCE"]["p_strSelectedID"] =
				$l_catdata["isys_catg_maintenance_list__isys_obj__id"];

			if ($_POST[C__GET__NAVMODE] == C__NAVMODE__SAVE) {
				if (!$this->is_post_data_valid()) {
					$l_rules["C__CONTACT__PERSON_FIRST_NAME"]["p_strValue"] =
						$l_posts["C__CONTACT__PERSON_FIRST_NAME"];
					$l_rules["C__CONTACT__PERSON_LAST_NAME"]["p_strValue"] =
						$l_posts["C__CONTACT__PERSON_LAST_NAME"];
					$l_rules["C__CONTACT__PERSON_MAIL_ADDRESS"]["p_strValue"] =
						$l_posts["C__CONTACT__PERSON_MAIL_ADDRESS"];
					$l_rules["C__CONTACT__PERSON_PHONE_COMPANY"]["p_strValue"] =
						$l_posts["C__CONTACT__PERSON_PHONE_COMPANY"];
					$l_rules["C__CONTACT__PERSON_PHONE_HOME"]["p_strValue"] =
						$l_posts["C__CONTACT__PERSON_PHONE_HOME"];
					$l_rules["C__CONTACT__PERSON_PHONE_MOBILE"]["p_strValue"] =
						$l_posts["C__CONTACT__PERSON_PHONE_MOBILE"];
					$l_rules["C__CONTACT__PERSON_FAX"]["p_strValue"] =
						$l_posts["C__CONTACT__PERSON_FAX"];
					$l_rules["C__CONTACT__PERSON_DEPARTMENT"]["p_strValue"] =
						$l_posts["C__CONTACT__PERSON_DEPARTMENT"];
					$l_rules["C__CONTACT__PERSON_ASSIGNED_ORGANISATION"]
						["p_strSelectedID"] =
						$l_posts["C__CONTACT__PERSON_ASSIGNED_ORGANISATION"];
					$l_rules["C__CONTACT__PERSON_USER_NAME"]["p_strValue"] =
						$l_posts["C__CONTACT__PERSON_USER_NAME"];

					$l_rules = isys_glob_array_merge(
						$l_rules,
						$this->m_cat->get_additional_rules());
				}
			}
			
			$l_tpl->smarty_tom_add_rules($this->get_str_target_tom(), $l_rules);
 		} else {
 			//throw new isys_exception_ui("Could not find data for this contact");
 		}

 		$l_tpl->smarty_tom_add_rule("tom.content.bottom.buttons.*.p_bInvisible=0");
 		
 		return "Detail Person";
 	}

 	/**
 	 * Initialize category, this is done by:
 	 * - Initialize the distributor
 	 * - Fetch the requested category from the category list
 	 * - Set DAO and UI for the View class
 	 *
 	 * @return boolean
 	 * @version - 2006-04-05
 	 * @throws isys_exception_cmdb
 	 */
 	public function category_init() {
 		return ISYS_FALSE;
 	}

 	public function handle_navmode($p_navmode) {
		if ($this->get_b_do_handle_navmode()){

			parent::handle_navmode($p_navmode);

			$l_posts = $this->get_module_request()->get_posts();
			$l_gets 	= $this->get_module_request()->get_gets();

			switch($p_navmode) {
				case C__NAVMODE__RESET:
				case C__NAVMODE__CANCEL:
					$l_gets[C__CMDB__GET__EDITMODE] =
						C__EDITMODE__OFF;
					$f[C__CONTACT__GET__MENU_SELECTION] =
						C__CONTACT_TREE__PERSON_MAIN;
					$l_gets[C__CMDB__GET__TREEMODE] =
						C__CONTACT__VIEW__TREE;
					$l_gets[C__CMDB__GET__VIEWMODE] =
						C__CONTACT__VIEW__LIST_PERSON;
					unset($l_posts[C__GET__NAVMODE]);
					$this->get_module_request()->_internal_set_private("m_get", $l_gets);
					$this->get_module_request()->_internal_set_private("m_post", $l_posts);
					$this->trigger_module_reload();
					break;

				case C__NAVMODE__SAVE:
					//$this->process();
					break;

				default:
					break;
			}
		}
	}

	public function get_template_top() {
		return "contact/detail_top.tpl";

	}

	public function get_template_bottom() {
		return "contact/detail_person.tpl";
	}

 	public function get_mandatory_parameters(&$l_gets) {
 		parent::get_mandatory_parameters($l_gets);
 	}

 	public function get_optional_parameters(&$l_gets) {
 		parent::get_optional_parameters($l_gets);
 	}

 	public function __construct(isys_module_request $p_modreq) {
 		global $g_comp_database;

 		parent::__construct($p_modreq);

 		$this->m_cat = new isys_cmdb_dao_category_g_contact($g_comp_database);
 	}
 }
?>
